From: Hannes Reinecke <hare@suse.de>
To: Sagi Grimberg <sagi@grimberg.me>
Cc: Christoph Hellwig <hch@lst.de>, Keith Busch <keith.busch@wdc.com>,
Omar Sandoval <osandov@fb.com>,
linux-nvme@lists.infradead.org, Hannes Reinecke <hare@suse.de>
Subject: [PATCH 6/6] nvmeof-tcp/006: test re-authentication
Date: Fri, 12 Nov 2021 15:45:10 +0100 [thread overview]
Message-ID: <20211112144510.98523-7-hare@suse.de> (raw)
In-Reply-To: <20211112144510.98523-1-hare@suse.de>
Signed-off-by: Hannes Reinecke <hare@suse.de>
---
tests/nvmeof-tcp/006 | 113 +++++++++++++++++++++++++++++++++++++++
tests/nvmeof-tcp/006.out | 23 ++++++++
2 files changed, 136 insertions(+)
create mode 100644 tests/nvmeof-tcp/006
create mode 100644 tests/nvmeof-tcp/006.out
diff --git a/tests/nvmeof-tcp/006 b/tests/nvmeof-tcp/006
new file mode 100644
index 0000000..7376879
--- /dev/null
+++ b/tests/nvmeof-tcp/006
@@ -0,0 +1,113 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-3.0+
+# Copyright (C) 2021 Hannes Reinecke, SUSE Labs
+#
+# Test nvme over tcp re-authentication
+
+. tests/nvmeof-tcp/rc
+
+DESCRIPTION="Test re-authentication for TCP connection via localhost"
+QUICK=1
+
+requires() {
+ _nvme_requires
+ _have_modules loop
+ _require_nvme_trtype_is_fabrics
+}
+
+
+test() {
+ local port
+ local genctr
+ local subsys="blktests-subsystem-"
+ local hostid="$(uuidgen)"
+ local hostnqn="nqn.2014-08.org.nvmexpress:uuid:${hostid}"
+ local scratch="/tmp/blktest-ns1.img"
+ local hostkey
+
+ echo "Running ${TEST_NAME}"
+
+ hostkey="$(nvme gen-dhchap-key -n ${subsys}1 2> /dev/null)"
+ if [ $? -ne 0 ] ; then
+ echo "nvme gen-dhchap-key command missing"
+ return 1
+ fi
+
+ ctrlkey="$(nvme gen-dhchap-key -n ${subsys}1 2> /dev/null)"
+ if [ $? -ne 0 ] ; then
+ echo "nvme gen-dhchap-key command missing"
+ return 1
+ fi
+
+ _setup_nvmet
+
+ truncate -s 512M "${scratch}"
+
+ port="$(_create_nvmet_port "${nvme_trtype}")"
+
+ _create_nvmet_subsystem "${subsys}1" "${scratch}"
+ _add_nvmet_subsys_to_port "${port}" "${subsys}1"
+ _create_nvmet_host "${subsys}1" "${hostnqn}" "${hostkey}"
+
+ _set_nvmet_dhgroup "${hostnqn}" "ffdhe2048"
+ _set_nvmet_ctrlkey "${hostnqn}" "${ctrlkey}"
+
+ nvme connect -t "${nvme_trtype}" -n "${subsys}1" \
+ -a "${def_traddr}" -s "${def_trsvcid}" \
+ -S "${hostkey}" -C "${ctrlkey}" \
+ --hostnqn="${hostnqn}" --hostid="${hostid}"
+
+ nvme list-subsys
+
+ ctrl=$(_find_nvme_dev "${subsys}1")
+
+ echo "Re-authenticate with original host key"
+
+ echo "${hostkey}" > /sys/class/nvme/${ctrl}/dhchap_secret
+
+ echo "Renew host key on the controller"
+
+ new_hostkey="$(nvme gen-dhchap-key -n ${subsys}1 2> /dev/null)"
+
+ _set_nvmet_hostkey "${hostnqn}" "${new_hostkey}"
+
+ echo "Re-authenticate with new host key"
+
+ echo "${new_hostkey}" > /sys/class/nvme/${ctrl}/dhchap_secret
+
+ nvme list-subsys
+
+ echo "Renew ctrl key on the controller"
+
+ new_ctrlkey="$(nvme gen-dhchap-key -n ${subsys}1 2> /dev/null)"
+
+ _set_nvmet_ctrlkey "${hostnqn}" "${new_ctrlkey}"
+
+ echo "Re-authenticate with new ctrl key"
+
+ echo "${new_ctrlkey}" > /sys/class/nvme/${ctrl}/dhchap_ctrl_secret
+
+ nvme list-subsys
+
+ echo "Change DH group to ffdhe8192"
+
+ _nvmet_set_dhgroup "${subsys}1" "ffdhe8192"
+
+ echo "Re-authenticate with changed DH group"
+ echo "${new_hostkey}" > /sys/class/nvme/${ctrl}/dhchap_secret
+
+ nvme list-subsys
+
+ nvme disconnect -n "${subsys}1"
+
+ _remove_nvmet_subsystem_from_port "${port}" "${subsys}1"
+ _remove_nvmet_subsystem "${subsys}1"
+
+ _remove_nvmet_port "${port}"
+
+ _remove_nvmet_host "${hostnqn}"
+
+ rm ${scratch}
+
+ echo "Test complete"
+}
diff --git a/tests/nvmeof-tcp/006.out b/tests/nvmeof-tcp/006.out
new file mode 100644
index 0000000..006d9fe
--- /dev/null
+++ b/tests/nvmeof-tcp/006.out
@@ -0,0 +1,23 @@
+Running nvmeof-tcp/006
+nvme-subsys0 - NQN=blktests-subsystem-1
+\
+ +- nvme0 tcp traddr=127.0.0.1,trsvcid=4420 live
+Re-authenticate with original host key
+Renew host key on the controller
+Re-authenticate with new host key
+nvme-subsys0 - NQN=blktests-subsystem-1
+\
+ +- nvme0 tcp traddr=127.0.0.1,trsvcid=4420 live
+Renew ctrl key on the controller
+Re-authenticate with new ctrl key
+nvme-subsys0 - NQN=blktests-subsystem-1
+\
+ +- nvme0 tcp traddr=127.0.0.1,trsvcid=4420 live
+Change DH group to ffdhe8192
+tests/nvmeof-tcp/006: line 94: _nvmet_set_dhgroup: command not found
+Re-authenticate with changed DH group
+nvme-subsys0 - NQN=blktests-subsystem-1
+\
+ +- nvme0 tcp traddr=127.0.0.1,trsvcid=4420 live
+NQN:blktests-subsystem-1 disconnected 1 controller(s)
+Test complete
--
2.26.2
prev parent reply other threads:[~2021-11-12 14:58 UTC|newest]
Thread overview: 17+ messages / expand[flat|nested] mbox.gz Atom feed top
2021-11-12 14:45 [PATCH blktests 0/6] Testsuite for nvme in-band authentication Hannes Reinecke
2021-11-12 14:45 ` [PATCH 1/6] nvmeof-tcp/001: simple test for nvmeof-tcp connection Hannes Reinecke
2021-11-14 10:31 ` Sagi Grimberg
2021-11-14 13:50 ` Hannes Reinecke
2021-11-14 14:45 ` Sagi Grimberg
2021-11-15 2:34 ` Chaitanya Kulkarni
2021-11-15 6:56 ` Hannes Reinecke
2021-11-15 8:12 ` Sagi Grimberg
2021-11-15 8:37 ` Hannes Reinecke
2021-11-12 14:45 ` [PATCH 2/6] nvmeof-tcp/002: create an authenticated " Hannes Reinecke
2021-11-12 14:45 ` [PATCH 3/6] nvmeof-tcp/003: test different key types Hannes Reinecke
2021-11-12 14:45 ` [PATCH 4/6] nvmeof-tcp/004: test hash and dhgroup variations Hannes Reinecke
2021-11-12 14:45 ` [PATCH 5/6] nvmeof-tcp/005: test bi-directional authentication Hannes Reinecke
2021-11-17 21:50 ` Sagi Grimberg
2021-11-18 9:40 ` Hannes Reinecke
2021-11-19 11:29 ` Hannes Reinecke
2021-11-12 14:45 ` Hannes Reinecke [this message]
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20211112144510.98523-7-hare@suse.de \
--to=hare@suse.de \
--cc=hch@lst.de \
--cc=keith.busch@wdc.com \
--cc=linux-nvme@lists.infradead.org \
--cc=osandov@fb.com \
--cc=sagi@grimberg.me \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.